/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { WorkflowCredentialsIn } from '../models/WorkflowCredentialsIn';
import type { WorkflowCredentialsOut } from '../models/WorkflowCredentialsOut';

import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';

export class WorkflowCredentialsService {

    /**
     * Get the credentials of a workflow
     * Get the credentials for the repository of a workflow. Only the developer of a workflow can do this.
     *
     * Permission "workflow:update" required.
     * @param wid ID of a workflow
     * @returns WorkflowCredentialsOut Successful Response
     * @throws ApiError
     */
    public static workflowCredentialsGetWorkflowCredentials(
        wid: string,
    ): CancelablePromise<WorkflowCredentialsOut> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/workflows/{wid}/credentials',
            path: {
                'wid': wid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Update the credentials of a workflow
     * Update the credentials for the repository of a workflow.
     *
     * Permission "workflow:update" required.
     * @param wid ID of a workflow
     * @param requestBody
     * @returns any Successful Response
     * @throws ApiError
     */
    public static workflowCredentialsUpdateWorkflowCredentials(
        wid: string,
        requestBody: WorkflowCredentialsIn,
    ): CancelablePromise<any> {
        return __request(OpenAPI, {
            method: 'PUT',
            url: '/workflows/{wid}/credentials',
            path: {
                'wid': wid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Delete the credentials of a workflow
     * Delete the credentials for the repository of a workflow.
     *
     * Permission "workflow:delete" required.
     * @param wid ID of a workflow
     * @returns void
     * @throws ApiError
     */
    public static workflowCredentialsDeleteWorkflowCredentials(
        wid: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/workflows/{wid}/credentials',
            path: {
                'wid': wid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

}
