/* generated using openapi-typescript-codegen -- do no edit */
/* istanbul ignore file */
/* tslint:disable */
/* eslint-disable */
import type { Body_Workflow_Version_upload_workflow_version_icon } from '../models/Body_Workflow_Version_upload_workflow_version_icon';
import type { DocumentationEnum } from '../models/DocumentationEnum';
import type { IconUpdateOut } from '../models/IconUpdateOut';
import type { Status } from '../models/Status';
import type { WorkflowVersion } from '../models/WorkflowVersion';
import type { WorkflowVersionStatus } from '../models/WorkflowVersionStatus';

import type { CancelablePromise } from '../core/CancelablePromise';
import { OpenAPI } from '../core/OpenAPI';
import { request as __request } from '../core/request';

export class WorkflowVersionService {

    /**
     * Get all versions of a workflow
     * List all versions of a Workflow.
     *
     * Permission "workflow:list" required.
     * @param wid ID of a workflow
     * @param versionStatus Which versions of the workflow to include in the response. Permission 'workflow:list_filter' required if you are not the developer of this workflow. Default PUBLISHED and DEPRECATED
     * @returns WorkflowVersion Successful Response
     * @throws ApiError
     */
    public static workflowVersionListWorkflowVersion(
        wid: string,
        versionStatus?: (Array<Status> | null),
    ): CancelablePromise<Array<WorkflowVersion>> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/workflows/{wid}/versions',
            path: {
                'wid': wid,
            },
            query: {
                'version_status': versionStatus,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Get a workflow version
     * Get a specific version of a workflow.
     *
     * Permission "workflow:read" required if the version is public or you are the developer of the workflow,
     * otherwise "workflow:read_any"
     * @param gitCommitHash Git commit git_commit_hash of specific version or 'latest'.
     * @param wid ID of a workflow
     * @returns WorkflowVersion Successful Response
     * @throws ApiError
     */
    public static workflowVersionGetWorkflowVersion(
        gitCommitHash: string,
        wid: string,
    ): CancelablePromise<WorkflowVersion> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/workflows/{wid}/versions/{git_commit_hash}',
            path: {
                'git_commit_hash': gitCommitHash,
                'wid': wid,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Update status of workflow version
     * Update the status of a workflow version.
     *
     * Permission "workflow:update_status"
     * @param gitCommitHash Git commit git_commit_hash of specific version.
     * @param wid ID of a workflow
     * @param requestBody
     * @returns WorkflowVersion Successful Response
     * @throws ApiError
     */
    public static workflowVersionUpdateWorkflowVersionStatus(
        gitCommitHash: string,
        wid: string,
        requestBody: WorkflowVersionStatus,
    ): CancelablePromise<WorkflowVersion> {
        return __request(OpenAPI, {
            method: 'PATCH',
            url: '/workflows/{wid}/versions/{git_commit_hash}/status',
            path: {
                'git_commit_hash': gitCommitHash,
                'wid': wid,
            },
            body: requestBody,
            mediaType: 'application/json',
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Deprecate a workflow version
     * Deprecate a workflow version.
     *
     * Permission "workflow:update" required if you are the developer of the workflow,
     * otherwise "workflow:read_status"
     * @param wid ID of a workflow
     * @param gitCommitHash Git commit git_commit_hash of specific version.
     * @returns WorkflowVersion Successful Response
     * @throws ApiError
     */
    public static workflowVersionDeprecateWorkflowVersion(
        wid: string,
        gitCommitHash: string,
    ): CancelablePromise<WorkflowVersion> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/workflows/{wid}/versions/{git_commit_hash}/deprecate',
            path: {
                'wid': wid,
                'git_commit_hash': gitCommitHash,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Fetch documentation for a workflow version
     * Get the documentation for a specific workflow version.
     * Streams the response directly from the right git repository.
     *
     * Permission "workflow:read" required.
     * @param wid ID of a workflow
     * @param gitCommitHash Git commit git_commit_hash of specific version.
     * @param document Specific which type of documentation the client wants to fetch
     * @param modeId Workflow Mode
     * @returns any Successful Response
     * @throws ApiError
     */
    public static workflowVersionDownloadWorkflowDocumentation(
        wid: string,
        gitCommitHash: string,
        document?: DocumentationEnum,
        modeId?: (string | null),
    ): CancelablePromise<any> {
        return __request(OpenAPI, {
            method: 'GET',
            url: '/workflows/{wid}/versions/{git_commit_hash}/documentation',
            path: {
                'wid': wid,
                'git_commit_hash': gitCommitHash,
            },
            query: {
                'document': document,
                'mode_id': modeId,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Upload icon for workflow version
     * Upload an icon for the workflow version and returns the new icon URL.
     *
     * Permission "workflow:update" required.
     * @param wid ID of a workflow
     * @param gitCommitHash Git commit git_commit_hash of specific version.
     * @param formData
     * @returns IconUpdateOut Successful Response
     * @throws ApiError
     */
    public static workflowVersionUploadWorkflowVersionIcon(
        wid: string,
        gitCommitHash: string,
        formData: Body_Workflow_Version_upload_workflow_version_icon,
    ): CancelablePromise<IconUpdateOut> {
        return __request(OpenAPI, {
            method: 'POST',
            url: '/workflows/{wid}/versions/{git_commit_hash}/icon',
            path: {
                'wid': wid,
                'git_commit_hash': gitCommitHash,
            },
            formData: formData,
            mediaType: 'multipart/form-data',
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

    /**
     * Delete icon of workflow version
     * Delete the icon of the workflow version.
     *
     * Permission "workflow:update" required.
     * @param wid ID of a workflow
     * @param gitCommitHash Git commit git_commit_hash of specific version.
     * @returns void
     * @throws ApiError
     */
    public static workflowVersionDeleteWorkflowVersionIcon(
        wid: string,
        gitCommitHash: string,
    ): CancelablePromise<void> {
        return __request(OpenAPI, {
            method: 'DELETE',
            url: '/workflows/{wid}/versions/{git_commit_hash}/icon',
            path: {
                'wid': wid,
                'git_commit_hash': gitCommitHash,
            },
            errors: {
                400: `Error decoding JWT Token`,
                403: `Not authenticated`,
                404: `Entity not Found`,
                422: `Validation Error`,
            },
        });
    }

}
