import type { WorkflowVersion } from "@/client/workflow";

export function sortedVersions(
  versions: WorkflowVersion[],
  desc = true,
): WorkflowVersion[] {
  const vs = [...versions];
  if (desc) {
    vs.sort((a, b) => (a.created_at < b.created_at ? 1 : -1));
  } else {
    vs.sort((a, b) => (a.created_at < b.created_at ? -1 : 1));
  }
  return vs;
}

export function latestVersion(
  versions: WorkflowVersion[],
): WorkflowVersion | undefined {
  if (versions == undefined || versions.length == 0) {
    return undefined;
  }
  const vs = sortedVersions(versions);
  return vs[0];
}
